<!-- markdownlint-disable MD033 -->
<img src="https://imagedelivery.net/B-Y55OAFnxqdmPWhf8E2OA/31d96444-4aa1-4a8a-dc03-192672a9ab00/githubBanner" alt="Sonr motor_flutter banner image for github and pub.dev">
<!-- markdownlint-enable MD033 -->

<div align="center">

[![Docs](https://img.shields.io/badge/API%20Docs-motor__flutter-blue.svg)](https://motor.build/motor_flutter/MotorFlutter-class.html)
[![Status](https://img.shields.io/badge/status-active-success.svg)](https://sonr.io)
[![License](https://img.shields.io/badge/license-GPLv3-blue.svg)](/LICENSE)

[![Pub](https://img.shields.io/pub/v/motor_flutter.svg)](https://pub.dev/packages/motor_flutter)
[![Pod](https://img.shields.io/cocoapods/v/motor_pod)](https://cocoapods.org/pods/motor_pod)
[![GitHub Issues](https://img.shields.io/github/issues/sonr-io/motor-flutter.svg)](https://github.com/sonr-io/motor-flutter/issues)

</div>

The Official Implementation of the Sonr Motor Node in Flutter. This package provides methods for Authentication, Data Management, and Wallet interactions for the Sonr Network.

**Quick Start**
- Get started by [Registering User Accounts](https://motor.build/motor_flutter/MotorFlutter/createAccount.html) and following the **next steps** at the bottom of the doc.
- Read the Full Sonr Stack [Documentation](https://docs.sonr.io) and Motor [Flutter API Reference](https://motor.build/motor_flutter/MotorFlutter-class.html)
- Visit our [Website](https://sonr.io) and Join the Community [Discord](https://sonr.io/discord)
- Submit Feature Requests at [sonr.fyi](https://sonr.fyi)

## Installation

Here's how to install the `motor_flutter` package in your Flutter project:

#### Prerequisites
* [Flutter](https://flutter.dev/docs/get-started/install)
* [GetX](https://pub.dev/packages/get)

Using the Flutter CLI

```sh
flutter pub add motor_flutter
```

or

```yaml
dependencies:
  motor_flutter: ^0.9.2
```

Update your `ios/Podfile`:

```ruby
platform :ios, '13.0' # At the top of the file
.
.
use_frameworks! # Then **remove or comment out**
```

## Usage

We have full usage examples available in the motor_flutter [docs site](https://motor.build/motor_flutter/motor_flutter-library.html). Each method on the
`MotorFlutter` class has a full example and usage guide for its functionality.


## Storybook

To run storybook, run flutter on storybook directory like so:
```
$ cd storybook
$ flutter run -d <your_device_id>
```

## Running tests
To run tests simply run this command:

```
$ flutter test
```

This repository uses [golden tests](https://api.flutter.dev/flutter/flutter_test/matchesGoldenFile.html), so whenever a widget structure is changed the tests will fail, if you actually want the changes to take place you can update the golden files with this command:

```
$ flutter test --update-goldens
```

### Coverage
To generate coverage reports first install lcov:

Linux
```
sudo apt-get update -qq -y
sudo apt-get install lcov -y
```

MacOS
```
brew install lcov
```

Use this command to generate coverage:
```
$ ./scripts/generate-coverage.sh
```

If you don't have permission to execute the script run this command and try again:
```
$ chmod 777 scripts/generate-coverage.sh
$ ./scripts/generate-coverage.sh
```

Now you can check coverage by opening coverage/html/index.html
```
$ open coverage/html/index.html
```

## Contributing

This library is still under active core team development. We welcome contributions from the community, but for the time being we would ask
that you create an issue before submitting a pull request.

## License

Our code is licensed under the [GPLv3](/LICENSE) license.
