import 'package:get/get.dart';
import 'package:motor_flutter/motor_flutter.dart';

class LoginController extends GetxController with StateMixin<WhoIs?> {
  @override
  void onInit() {
    super.onInit();
    change(null, status: RxStatus.empty());
  }

  login({required String password, required String address}) async {
    // Set status to loading
    change(null, status: RxStatus.loading());

    // Login
    try {
      final res =
          await MotorFlutter.to.login(password: password, address: address);
      // Set whois
      change(res, status: RxStatus.success());
    } catch (e) {
      change(null, status: RxStatus.error("Internal Error - Failed to login"));
      return;
    }
  }
}
