import 'package:flutter/material.dart';
import 'package:motor_flutter/src/widgets/shared/sonr_text_input.dart';

class SonrPasswordInput extends StatefulWidget {
  final TextEditingController? controller;

  const SonrPasswordInput({
    super.key, 
    this.controller, 
  });

  @override
  State<SonrPasswordInput> createState() => _SonrPasswordInputState();
}

class _SonrPasswordInputState extends State<SonrPasswordInput> {
  bool _passwordIsHidden = true;

  togglePasswordVisibility(){
    setState(() { _passwordIsHidden = !_passwordIsHidden; });
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      child: SonrTextInput(
        label: 'Your Vault Password',
        obscureText: _passwordIsHidden,
        controller: widget.controller,
        prefixIcon: Icon(Icons.key),
        suffixIcon: _passwordIsHidden ? Icon(Icons.visibility_off) : Icon(Icons.visibility),
        suffixOnPress: togglePasswordVisibility,
      ),
    );
  }
}