import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:motor_flutter/src/widgets/widgets.dart';

Widget _mockButtonWidgetsTree(Widget child) {
  return MaterialApp(
    home: Scaffold(
      body: Center(
        child: SizedBox(
          height: 40,
          child: child,
        ),
      ),
    ),
  );
}

void main() {
  testWidgets('LoginButton should render whitout errors', (tester) async {
    await tester.pumpWidget(
      _mockButtonWidgetsTree(LoginButton()),
    );

    final labelWidget = find.text('Connect with Sonr');

    expect(labelWidget, findsOneWidget);
  });

  testWidgets('LoginButton golden test', (tester) async {
    await tester.pumpWidget(
      _mockButtonWidgetsTree(LoginButton()),
    );

    await expectLater(
      find.byType(LoginButton),
      matchesGoldenFile('login_button.png'),
    );
  });
}
